/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: mife.h,v 1.1 2003/11/26 04:07:05 babolo Exp $
 */

#define MIFE_RTRY    0x00FF
#define MIFE_FULL    0x0100
#define MIFE_INMM    0x0200
#define MIFE_SDUP    0x0400
#define MIFE_CLOS    0x0800
#define MIFE_VERB    0x1000
#define MIFE_VERM    0x2000
#define MIFE_VERD    0x4000
#define MIFE_VERH    0x8000
#define MIFE_VERMASK 0xF000

struct mife_descriptor {
    u_int32_t flag;   /*                             */
    int fd;           /*          */
    ssize_t mindelta;
    size_t len;       /*         */
    size_t buflen;    /*                      */
    void *buffer;     /*                             */
    off_t offset;     /*       */
};

struct mife_descriptor * mife_opef __P((int, u_int32_t));
struct mife_descriptor * mife_open __P((const char *, u_int32_t));
struct mife_descriptor * mife_opes __P((u_int32_t, const char *, size_t));
struct mife_descriptor * mife_opem __P((u_int32_t, char *, size_t));

ssize_t mife_read __P((struct mife_descriptor *, size_t, off_t));
void *   mife_get __P((struct mife_descriptor *, off_t));
int    mife_close __P((struct mife_descriptor *));
ssize_t mife_writ __P((int, const void *, size_t));
